
_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;JJYClock.mbas,78 :: 		sub procedure interrupt     ' 1msec period
;JJYClock.mbas,79 :: 		if TMR2IF_bit = true then
	BTFSS      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L__interrupt2
;JJYClock.mbas,80 :: 		pulse_width = pulse_width + 1
	INCF       _pulse_width+0, 1
	BTFSC      STATUS+0, 2
	INCF       _pulse_width+1, 1
;JJYClock.mbas,81 :: 		if msec < 1000 then
	MOVLW      3
	SUBWF      _msec+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt312
	MOVLW      232
	SUBWF      _msec+0, 0
L__interrupt312:
	BTFSC      STATUS+0, 0
	GOTO       L__interrupt5
;JJYClock.mbas,82 :: 		msec = msec + 1
	INCF       _msec+0, 1
	BTFSC      STATUS+0, 2
	INCF       _msec+1, 1
	GOTO       L__interrupt6
;JJYClock.mbas,83 :: 		else
L__interrupt5:
;JJYClock.mbas,84 :: 		msec = 0
	CLRF       _msec+0
	CLRF       _msec+1
;JJYClock.mbas,85 :: 		seconds = seconds + 1
	INCF       _seconds+0, 1
	BTFSC      STATUS+0, 2
	INCF       _seconds+1, 1
;JJYClock.mbas,86 :: 		end if
L__interrupt6:
;JJYClock.mbas,87 :: 		if disable_time_zone then
	MOVF       _disable_time_zone+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt8
;JJYClock.mbas,88 :: 		disable_msec = disable_msec + 1
	INCF       _disable_msec+0, 1
	BTFSC      STATUS+0, 2
	INCF       _disable_msec+1, 1
L__interrupt8:
;JJYClock.mbas,90 :: 		if seconds_reset then
	MOVF       _seconds_reset+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt11
;JJYClock.mbas,91 :: 		msec    = 0
	CLRF       _msec+0
	CLRF       _msec+1
;JJYClock.mbas,92 :: 		seconds = 0
	CLRF       _seconds+0
	CLRF       _seconds+1
;JJYClock.mbas,93 :: 		seconds_reset = false
	CLRF       _seconds_reset+0
L__interrupt11:
;JJYClock.mbas,95 :: 		if pulse_width_reset then
	MOVF       _pulse_width_reset+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt14
;JJYClock.mbas,96 :: 		pulse_width = 0
	CLRF       _pulse_width+0
	CLRF       _pulse_width+1
;JJYClock.mbas,97 :: 		pulse_width_reset = false
	CLRF       _pulse_width_reset+0
L__interrupt14:
;JJYClock.mbas,99 :: 		TMR2IF_bit = false
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
L__interrupt2:
;JJYClock.mbas,101 :: 		end sub
L_end_interrupt:
L__interrupt311:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_is_leapyear:

;JJYClock.mbas,106 :: 		sub function is_leapyear( dim year as byte ) as boolean
;JJYClock.mbas,107 :: 		if year mod 4 = 0 then
	MOVLW      3
	ANDWF      FARG_is_leapyear_year+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__is_leapyear18
;JJYClock.mbas,108 :: 		if year mod 100 = 0 then
	MOVLW      100
	MOVWF      R4+0
	MOVF       FARG_is_leapyear_year+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__is_leapyear21
;JJYClock.mbas,109 :: 		if year mod 400 = 0 then
	MOVLW      144
	MOVWF      R4+0
	MOVLW      1
	MOVWF      R4+1
	MOVF       FARG_is_leapyear_year+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVLW      0
	XORWF      R0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__is_leapyear314
	MOVLW      0
	XORWF      R0+0, 0
L__is_leapyear314:
	BTFSS      STATUS+0, 2
	GOTO       L__is_leapyear24
;JJYClock.mbas,110 :: 		result = true
	MOVLW      255
	MOVWF      is_leapyear_local_result+0
	GOTO       L__is_leapyear25
;JJYClock.mbas,111 :: 		else
L__is_leapyear24:
;JJYClock.mbas,112 :: 		result = false
	CLRF       is_leapyear_local_result+0
;JJYClock.mbas,113 :: 		end if
L__is_leapyear25:
	GOTO       L__is_leapyear22
;JJYClock.mbas,114 :: 		else
L__is_leapyear21:
;JJYClock.mbas,115 :: 		result = true
	MOVLW      255
	MOVWF      is_leapyear_local_result+0
;JJYClock.mbas,116 :: 		end if
L__is_leapyear22:
	GOTO       L__is_leapyear19
;JJYClock.mbas,117 :: 		else
L__is_leapyear18:
;JJYClock.mbas,118 :: 		result = false
	CLRF       is_leapyear_local_result+0
;JJYClock.mbas,119 :: 		end if
L__is_leapyear19:
;JJYClock.mbas,120 :: 		end sub
	MOVF       is_leapyear_local_result+0, 0
	MOVWF      R0+0
L_end_is_leapyear:
	RETURN
; end of _is_leapyear

_decode_minutes:

;JJYClock.mbas,126 :: 		dim index as byte
;JJYClock.mbas,128 :: 		for index = 1 to 8
	MOVLW      1
	MOVWF      decode_minutes_index+0
L__decode_minutes28:
;JJYClock.mbas,129 :: 		if time_code[index] > 1 then
	MOVF       decode_minutes_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__decode_minutes33
;JJYClock.mbas,130 :: 		result = 100
	MOVLW      100
	MOVWF      decode_minutes_local_result+0
;JJYClock.mbas,131 :: 		exit
	GOTO       L_end__decode_minutes
L__decode_minutes33:
;JJYClock.mbas,133 :: 		next index
	MOVF       decode_minutes_index+0, 0
	XORLW      8
	BTFSC      STATUS+0, 2
	GOTO       L__decode_minutes31
	INCF       decode_minutes_index+0, 1
	GOTO       L__decode_minutes28
L__decode_minutes31:
;JJYClock.mbas,134 :: 		result = 40 * time_code[1] +
	MOVLW      40
	MOVWF      R0+0
	MOVF       _time_code+1, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__decode_minutes+0
	MOVLW      20
	MOVWF      R0+0
	MOVF       _time_code+2, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
;JJYClock.mbas,135 :: 		20 * time_code[2] +
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_minutes+0, 1
;JJYClock.mbas,136 :: 		10 * time_code[3] +
	MOVLW      10
	MOVWF      R0+0
	MOVF       _time_code+3, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_minutes+0, 0
	MOVWF      R2+0
;JJYClock.mbas,137 :: 		8 * time_code[5] +
	MOVF       _time_code+5, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R2+0, 1
;JJYClock.mbas,138 :: 		4 * time_code[6] +
	MOVF       _time_code+6, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R2+0, 1
;JJYClock.mbas,139 :: 		2 * time_code[7] +
	MOVF       _time_code+7, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R2+0, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,140 :: 		1 * time_code[8]
	MOVF       _time_code+8, 0
	ADDWF      R0+0, 0
	MOVWF      decode_minutes_local_result+0
;JJYClock.mbas,141 :: 		end sub
L_end__decode_minutes:
	MOVF       decode_minutes_local_result+0, 0
	MOVWF      R0+0
L_end_decode_minutes:
	RETURN
; end of _decode_minutes

_decode_hours:

;JJYClock.mbas,147 :: 		dim index as byte
;JJYClock.mbas,149 :: 		for index = 10 to 18
	MOVLW      10
	MOVWF      decode_hours_index+0
L__decode_hours37:
;JJYClock.mbas,150 :: 		if time_code[index] > 1 then
	MOVF       decode_hours_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__decode_hours42
;JJYClock.mbas,151 :: 		result = 100
	MOVLW      100
	MOVWF      decode_hours_local_result+0
;JJYClock.mbas,152 :: 		exit
	GOTO       L_end__decode_hours
L__decode_hours42:
;JJYClock.mbas,154 :: 		next index
	MOVF       decode_hours_index+0, 0
	XORLW      18
	BTFSC      STATUS+0, 2
	GOTO       L__decode_hours40
	INCF       decode_hours_index+0, 1
	GOTO       L__decode_hours37
L__decode_hours40:
;JJYClock.mbas,155 :: 		result = 20 * time_code[12] +
	MOVLW      20
	MOVWF      R0+0
	MOVF       _time_code+12, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__decode_hours+0
	MOVLW      10
	MOVWF      R0+0
	MOVF       _time_code+13, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
;JJYClock.mbas,156 :: 		10 * time_code[13] +
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_hours+0, 0
	MOVWF      R2+0
;JJYClock.mbas,157 :: 		8 * time_code[15] +
	MOVF       _time_code+15, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R2+0, 1
;JJYClock.mbas,158 :: 		4 * time_code[16] +
	MOVF       _time_code+16, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R2+0, 1
;JJYClock.mbas,159 :: 		2 * time_code[17] +
	MOVF       _time_code+17, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R2+0, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,160 :: 		1 * time_code[18]
	MOVF       _time_code+18, 0
	ADDWF      R0+0, 0
	MOVWF      decode_hours_local_result+0
;JJYClock.mbas,161 :: 		end sub
L_end__decode_hours:
	MOVF       decode_hours_local_result+0, 0
	MOVWF      R0+0
L_end_decode_hours:
	RETURN
; end of _decode_hours

_decode_year:

;JJYClock.mbas,167 :: 		dim index as byte
;JJYClock.mbas,169 :: 		for index = 41 to 48
	MOVLW      41
	MOVWF      decode_year_index+0
L__decode_year46:
;JJYClock.mbas,170 :: 		if time_code[index] > 1 then
	MOVF       decode_year_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__decode_year51
;JJYClock.mbas,171 :: 		result = 100
	MOVLW      100
	MOVWF      decode_year_local_result+0
;JJYClock.mbas,172 :: 		exit
	GOTO       L_end__decode_year
L__decode_year51:
;JJYClock.mbas,174 :: 		next index
	MOVF       decode_year_index+0, 0
	XORLW      48
	BTFSC      STATUS+0, 2
	GOTO       L__decode_year49
	INCF       decode_year_index+0, 1
	GOTO       L__decode_year46
L__decode_year49:
;JJYClock.mbas,176 :: 		result = 80 * time_code[41] +
	MOVLW      80
	MOVWF      R0+0
	MOVF       _time_code+41, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__decode_year+0
	MOVLW      40
	MOVWF      R0+0
	MOVF       _time_code+42, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
;JJYClock.mbas,177 :: 		40 * time_code[42] +
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_year+0, 1
;JJYClock.mbas,178 :: 		20 * time_code[43] +
	MOVLW      20
	MOVWF      R0+0
	MOVF       _time_code+43, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_year+0, 1
;JJYClock.mbas,179 :: 		10 * time_code[44] +
	MOVLW      10
	MOVWF      R0+0
	MOVF       _time_code+44, 0
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_year+0, 0
	MOVWF      R2+0
;JJYClock.mbas,180 :: 		8 * time_code[45] +
	MOVF       _time_code+45, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R2+0, 1
;JJYClock.mbas,181 :: 		4 * time_code[46] +
	MOVF       _time_code+46, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R2+0, 1
;JJYClock.mbas,182 :: 		2 * time_code[47] +
	MOVF       _time_code+47, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R2+0, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,183 :: 		1 * time_code[48]
	MOVF       _time_code+48, 0
	ADDWF      R0+0, 0
	MOVWF      decode_year_local_result+0
;JJYClock.mbas,184 :: 		end sub
L_end__decode_year:
	MOVF       decode_year_local_result+0, 0
	MOVWF      R0+0
L_end_decode_year:
	RETURN
; end of _decode_year

_decode_total_days:

;JJYClock.mbas,190 :: 		dim index as byte
;JJYClock.mbas,192 :: 		for index = 23 to 28
	MOVLW      23
	MOVWF      decode_total_days_index+0
L__decode_total_days55:
;JJYClock.mbas,193 :: 		if time_code[index] > 1 then
	MOVF       decode_total_days_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__decode_total_days60
;JJYClock.mbas,194 :: 		result = -1
	MOVLW      255
	MOVWF      decode_total_days_local_result+0
	MOVLW      255
	MOVWF      decode_total_days_local_result+1
;JJYClock.mbas,195 :: 		exit
	GOTO       L_end__decode_total_days
L__decode_total_days60:
;JJYClock.mbas,197 :: 		next index
	MOVF       decode_total_days_index+0, 0
	XORLW      28
	BTFSC      STATUS+0, 2
	GOTO       L__decode_total_days58
	INCF       decode_total_days_index+0, 1
	GOTO       L__decode_total_days55
L__decode_total_days58:
;JJYClock.mbas,198 :: 		for index = 30 to 38
	MOVLW      30
	MOVWF      decode_total_days_index+0
L__decode_total_days63:
;JJYClock.mbas,199 :: 		if time_code[index] > 1 then
	MOVF       decode_total_days_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__decode_total_days68
;JJYClock.mbas,200 :: 		result = -1
	MOVLW      255
	MOVWF      decode_total_days_local_result+0
	MOVLW      255
	MOVWF      decode_total_days_local_result+1
;JJYClock.mbas,201 :: 		exit
	GOTO       L_end__decode_total_days
L__decode_total_days68:
;JJYClock.mbas,203 :: 		next index
	MOVF       decode_total_days_index+0, 0
	XORLW      38
	BTFSC      STATUS+0, 2
	GOTO       L__decode_total_days66
	INCF       decode_total_days_index+0, 1
	GOTO       L__decode_total_days63
L__decode_total_days66:
;JJYClock.mbas,205 :: 		result = 200 * time_code[22] +
	MOVLW      200
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       _time_code+22, 0
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__decode_total_days+0
	MOVF       R0+1, 0
	MOVWF      FLOC__decode_total_days+1
	MOVLW      100
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       _time_code+23, 0
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Mul_16x16_U+0
;JJYClock.mbas,206 :: 		100 * time_code[23] +
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_total_days+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      FLOC__decode_total_days+1, 1
;JJYClock.mbas,207 :: 		80 * time_code[25] +
	MOVLW      80
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       _time_code+25, 0
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_total_days+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      FLOC__decode_total_days+1, 1
;JJYClock.mbas,208 :: 		40 * time_code[26] +
	MOVLW      40
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       _time_code+26, 0
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_total_days+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      FLOC__decode_total_days+1, 1
;JJYClock.mbas,209 :: 		20 * time_code[27] +
	MOVLW      20
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       _time_code+27, 0
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_total_days+0, 1
	MOVF       R0+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      FLOC__decode_total_days+1, 1
;JJYClock.mbas,210 :: 		10 * time_code[28] +
	MOVLW      10
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       _time_code+28, 0
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Mul_16x16_U+0
	MOVF       R0+0, 0
	ADDWF      FLOC__decode_total_days+0, 0
	MOVWF      R3+0
	MOVF       FLOC__decode_total_days+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      R3+1
;JJYClock.mbas,211 :: 		8 * time_code[30] +
	MOVLW      3
	MOVWF      R2+0
	MOVF       _time_code+30, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       R2+0, 0
L__decode_total_days319:
	BTFSC      STATUS+0, 2
	GOTO       L__decode_total_days320
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__decode_total_days319
L__decode_total_days320:
	MOVF       R0+0, 0
	ADDWF      R3+0, 0
	MOVWF      R6+0
	MOVF       R3+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      R6+1
;JJYClock.mbas,212 :: 		4 * time_code[31] +
	MOVF       _time_code+31, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R6+0, 0
	MOVWF      R4+0
	MOVF       R6+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      R4+1
;JJYClock.mbas,213 :: 		2 * time_code[32] +
	MOVF       _time_code+32, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	MOVF       R0+0, 0
	ADDWF      R4+0, 0
	MOVWF      R2+0
	MOVF       R4+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      R2+1
;JJYClock.mbas,214 :: 		1 * time_code[33]
	MOVF       _time_code+33, 0
	MOVWF      R0+0
	CLRF       R0+1
	MOVF       R0+0, 0
	ADDWF      R2+0, 0
	MOVWF      decode_total_days_local_result+0
	MOVF       R2+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 0
	MOVWF      decode_total_days_local_result+1
;JJYClock.mbas,215 :: 		end sub
L_end__decode_total_days:
	MOVF       decode_total_days_local_result+0, 0
	MOVWF      R0+0
	MOVF       decode_total_days_local_result+1, 0
	MOVWF      R0+1
L_end_decode_total_days:
	RETURN
; end of _decode_total_days

_decode_date:

;JJYClock.mbas,223 :: 		const days_table as byte[12] = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 )
;JJYClock.mbas,225 :: 		total_days = decode_total_days()
	CALL       _decode_total_days+0
	MOVF       R0+0, 0
	MOVWF      decode_date_total_days+0
	MOVF       R0+1, 0
	MOVWF      decode_date_total_days+1
;JJYClock.mbas,226 :: 		if total_days = -1 then
	MOVLW      255
	XORWF      R0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date322
	MOVLW      255
	XORWF      R0+0, 0
L__decode_date322:
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date72
;JJYClock.mbas,227 :: 		result = 100
	MOVLW      100
	MOVWF      decode_date_local_result+0
;JJYClock.mbas,228 :: 		exit
	GOTO       L_end__decode_date
L__decode_date72:
;JJYClock.mbas,231 :: 		for month = 1 to 12
	MOVLW      1
	MOVWF      decode_date_month+0
	CLRF       decode_date_month+1
L__decode_date75:
;JJYClock.mbas,232 :: 		if month = 2 then
	MOVLW      0
	XORWF      decode_date_month+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date323
	MOVLW      2
	XORWF      decode_date_month+0, 0
L__decode_date323:
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date80
;JJYClock.mbas,233 :: 		if leapyear then
	MOVF       FARG_decode_date_leapyear+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__decode_date83
;JJYClock.mbas,234 :: 		if total_days <= 29 then
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      decode_date_total_days+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date324
	MOVF       decode_date_total_days+0, 0
	SUBLW      29
L__decode_date324:
	BTFSS      STATUS+0, 0
	GOTO       L__decode_date86
;JJYClock.mbas,235 :: 		break
	GOTO       L__decode_date78
;JJYClock.mbas,236 :: 		else
L__decode_date86:
;JJYClock.mbas,237 :: 		total_days = total_days - 29
	MOVLW      29
	SUBWF      decode_date_total_days+0, 1
	BTFSS      STATUS+0, 0
	DECF       decode_date_total_days+1, 1
;JJYClock.mbas,238 :: 		end if
	GOTO       L__decode_date84
;JJYClock.mbas,239 :: 		else
L__decode_date83:
;JJYClock.mbas,240 :: 		if total_days <= 28 then
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      decode_date_total_days+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date325
	MOVF       decode_date_total_days+0, 0
	SUBLW      28
L__decode_date325:
	BTFSS      STATUS+0, 0
	GOTO       L__decode_date89
;JJYClock.mbas,241 :: 		break
	GOTO       L__decode_date78
;JJYClock.mbas,242 :: 		else
L__decode_date89:
;JJYClock.mbas,243 :: 		total_days = total_days - 28
	MOVLW      28
	SUBWF      decode_date_total_days+0, 1
	BTFSS      STATUS+0, 0
	DECF       decode_date_total_days+1, 1
;JJYClock.mbas,245 :: 		end if
L__decode_date84:
	GOTO       L__decode_date81
;JJYClock.mbas,246 :: 		else
L__decode_date80:
;JJYClock.mbas,247 :: 		if total_days <= days_table[month-1] then
	DECF       decode_date_month+0, 0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      decode_date_days_table+0
	ADDWF      R0+0, 1
	MOVLW      hi_addr(decode_date_days_table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R1+0
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      decode_date_total_days+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date326
	MOVF       decode_date_total_days+0, 0
	SUBWF      R1+0, 0
L__decode_date326:
	BTFSS      STATUS+0, 0
	GOTO       L__decode_date92
;JJYClock.mbas,248 :: 		break
	GOTO       L__decode_date78
;JJYClock.mbas,249 :: 		else
L__decode_date92:
;JJYClock.mbas,250 :: 		total_days = total_days - days_table[month-1]
	DECF       decode_date_month+0, 0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      decode_date_days_table+0
	ADDWF      R0+0, 1
	MOVLW      hi_addr(decode_date_days_table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R0+0
	MOVF       R0+0, 0
	SUBWF      decode_date_total_days+0, 1
	BTFSS      STATUS+0, 0
	DECF       decode_date_total_days+1, 1
;JJYClock.mbas,252 :: 		end if
L__decode_date81:
;JJYClock.mbas,253 :: 		next month
	MOVLW      0
	XORWF      decode_date_month+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_date327
	MOVLW      12
	XORWF      decode_date_month+0, 0
L__decode_date327:
	BTFSC      STATUS+0, 2
	GOTO       L__decode_date78
	INCF       decode_date_month+0, 1
	BTFSC      STATUS+0, 2
	INCF       decode_date_month+1, 1
	GOTO       L__decode_date75
L__decode_date78:
;JJYClock.mbas,255 :: 		result = total_days
	MOVF       decode_date_total_days+0, 0
	MOVWF      decode_date_local_result+0
;JJYClock.mbas,256 :: 		end sub
L_end__decode_date:
	MOVF       decode_date_local_result+0, 0
	MOVWF      R0+0
L_end_decode_date:
	RETURN
; end of _decode_date

_decode_month:

;JJYClock.mbas,264 :: 		const days_table as byte[12] = ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 )
;JJYClock.mbas,266 :: 		total_days = decode_total_days()
	CALL       _decode_total_days+0
	MOVF       R0+0, 0
	MOVWF      decode_month_total_days+0
	MOVF       R0+1, 0
	MOVWF      decode_month_total_days+1
;JJYClock.mbas,267 :: 		if total_days = -1 then
	MOVLW      255
	XORWF      R0+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month329
	MOVLW      255
	XORWF      R0+0, 0
L__decode_month329:
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month96
;JJYClock.mbas,268 :: 		result = 100
	MOVLW      100
	MOVWF      decode_month_local_result+0
;JJYClock.mbas,269 :: 		exit
	GOTO       L_end__decode_month
L__decode_month96:
;JJYClock.mbas,272 :: 		for month = 1 to 12
	MOVLW      1
	MOVWF      decode_month_month+0
	CLRF       decode_month_month+1
L__decode_month99:
;JJYClock.mbas,273 :: 		if month = 2 then
	MOVLW      0
	XORWF      decode_month_month+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month330
	MOVLW      2
	XORWF      decode_month_month+0, 0
L__decode_month330:
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month104
;JJYClock.mbas,274 :: 		if leapyear then
	MOVF       FARG_decode_month_leapyear+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__decode_month107
;JJYClock.mbas,275 :: 		if total_days <= 29 then
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      decode_month_total_days+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month331
	MOVF       decode_month_total_days+0, 0
	SUBLW      29
L__decode_month331:
	BTFSS      STATUS+0, 0
	GOTO       L__decode_month110
;JJYClock.mbas,276 :: 		break
	GOTO       L__decode_month102
;JJYClock.mbas,277 :: 		else
L__decode_month110:
;JJYClock.mbas,278 :: 		total_days = total_days - 29
	MOVLW      29
	SUBWF      decode_month_total_days+0, 1
	BTFSS      STATUS+0, 0
	DECF       decode_month_total_days+1, 1
;JJYClock.mbas,279 :: 		end if
	GOTO       L__decode_month108
;JJYClock.mbas,280 :: 		else
L__decode_month107:
;JJYClock.mbas,281 :: 		if total_days <= 28 then
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      decode_month_total_days+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month332
	MOVF       decode_month_total_days+0, 0
	SUBLW      28
L__decode_month332:
	BTFSS      STATUS+0, 0
	GOTO       L__decode_month113
;JJYClock.mbas,282 :: 		break
	GOTO       L__decode_month102
;JJYClock.mbas,283 :: 		else
L__decode_month113:
;JJYClock.mbas,284 :: 		total_days = total_days - 28
	MOVLW      28
	SUBWF      decode_month_total_days+0, 1
	BTFSS      STATUS+0, 0
	DECF       decode_month_total_days+1, 1
;JJYClock.mbas,286 :: 		end if
L__decode_month108:
	GOTO       L__decode_month105
;JJYClock.mbas,287 :: 		else
L__decode_month104:
;JJYClock.mbas,288 :: 		if total_days <= days_table[month-1] then
	DECF       decode_month_month+0, 0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      decode_month_days_table+0
	ADDWF      R0+0, 1
	MOVLW      hi_addr(decode_month_days_table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R1+0
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      decode_month_total_days+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month333
	MOVF       decode_month_total_days+0, 0
	SUBWF      R1+0, 0
L__decode_month333:
	BTFSS      STATUS+0, 0
	GOTO       L__decode_month116
;JJYClock.mbas,289 :: 		break
	GOTO       L__decode_month102
;JJYClock.mbas,290 :: 		else
L__decode_month116:
;JJYClock.mbas,291 :: 		total_days = total_days - days_table[month-1]
	DECF       decode_month_month+0, 0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      decode_month_days_table+0
	ADDWF      R0+0, 1
	MOVLW      hi_addr(decode_month_days_table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	ADDWF      R0+1, 1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R0+0
	MOVF       R0+0, 0
	SUBWF      decode_month_total_days+0, 1
	BTFSS      STATUS+0, 0
	DECF       decode_month_total_days+1, 1
;JJYClock.mbas,293 :: 		end if
L__decode_month105:
;JJYClock.mbas,294 :: 		next month
	MOVLW      0
	XORWF      decode_month_month+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__decode_month334
	MOVLW      12
	XORWF      decode_month_month+0, 0
L__decode_month334:
	BTFSC      STATUS+0, 2
	GOTO       L__decode_month102
	INCF       decode_month_month+0, 1
	BTFSC      STATUS+0, 2
	INCF       decode_month_month+1, 1
	GOTO       L__decode_month99
L__decode_month102:
;JJYClock.mbas,296 :: 		result = month
	MOVF       decode_month_month+0, 0
	MOVWF      decode_month_local_result+0
;JJYClock.mbas,297 :: 		end sub
L_end__decode_month:
	MOVF       decode_month_local_result+0, 0
	MOVWF      R0+0
L_end_decode_month:
	RETURN
; end of _decode_month

_decode_day:

;JJYClock.mbas,303 :: 		dim index as byte
;JJYClock.mbas,305 :: 		for index = 50 to 52
	MOVLW      50
	MOVWF      R4+0
L__decode_day120:
;JJYClock.mbas,306 :: 		if time_code[index] > 1 then
	MOVF       R4+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__decode_day125
;JJYClock.mbas,307 :: 		result = 100
	MOVLW      100
	MOVWF      R3+0
;JJYClock.mbas,308 :: 		exit
	GOTO       L_end__decode_day
L__decode_day125:
;JJYClock.mbas,310 :: 		next index
	MOVF       R4+0, 0
	XORLW      52
	BTFSC      STATUS+0, 2
	GOTO       L__decode_day123
	INCF       R4+0, 1
	GOTO       L__decode_day120
L__decode_day123:
;JJYClock.mbas,312 :: 		result =  4 * time_code[50] +
	MOVF       _time_code+50, 0
	MOVWF      R2+0
	RLF        R2+0, 1
	BCF        R2+0, 0
	RLF        R2+0, 1
	BCF        R2+0, 0
;JJYClock.mbas,313 :: 		2 * time_code[51] +
	MOVF       _time_code+51, 0
	MOVWF      R0+0
	RLF        R0+0, 1
	BCF        R0+0, 0
	MOVF       R2+0, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,314 :: 		1 * time_code[52]
	MOVF       _time_code+52, 0
	ADDWF      R0+0, 0
	MOVWF      R3+0
;JJYClock.mbas,315 :: 		end sub
L_end__decode_day:
	MOVF       R3+0, 0
	MOVWF      R0+0
L_end_decode_day:
	RETURN
; end of _decode_day

_display_minutes:

;JJYClock.mbas,320 :: 		sub procedure display_minutes( dim minutes as byte )
;JJYClock.mbas,321 :: 		Lcd_Out(1,10, "--:" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      45
	MOVWF      ?LocalText_display_minutes+0
	MOVLW      45
	MOVWF      ?LocalText_display_minutes+1
	MOVLW      58
	MOVWF      ?LocalText_display_minutes+2
	CLRF       ?LocalText_display_minutes+3
	MOVLW      ?LocalText_display_minutes+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,322 :: 		if minutes <= 59 then
	MOVF       FARG_display_minutes_minutes+0, 0
	SUBLW      59
	BTFSS      STATUS+0, 0
	GOTO       L__display_minutes129
;JJYClock.mbas,323 :: 		Lcd_Chr(1,13, ( minutes /   10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      13
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_minutes_minutes+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,324 :: 		Lcd_Chr(1,14, ( minutes mod 10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      14
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_minutes_minutes+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_minutes130
;JJYClock.mbas,325 :: 		else
L__display_minutes129:
;JJYClock.mbas,326 :: 		Lcd_Out(1,13, "ee" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      13
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      101
	MOVWF      ?LocalText_display_minutes+0
	MOVLW      101
	MOVWF      ?LocalText_display_minutes+1
	CLRF       ?LocalText_display_minutes+2
	MOVLW      ?LocalText_display_minutes+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,327 :: 		end if
L__display_minutes130:
;JJYClock.mbas,328 :: 		end sub
L_end_display_minutes:
	RETURN
; end of _display_minutes

_display_hour:

;JJYClock.mbas,333 :: 		sub procedure display_hour( dim hour as byte )
;JJYClock.mbas,334 :: 		Lcd_Out(1,4, "--/-- " )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      45
	MOVWF      ?LocalText_display_hour+0
	MOVLW      45
	MOVWF      ?LocalText_display_hour+1
	MOVLW      47
	MOVWF      ?LocalText_display_hour+2
	MOVLW      45
	MOVWF      ?LocalText_display_hour+3
	MOVLW      45
	MOVWF      ?LocalText_display_hour+4
	MOVLW      32
	MOVWF      ?LocalText_display_hour+5
	CLRF       ?LocalText_display_hour+6
	MOVLW      ?LocalText_display_hour+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,335 :: 		if hour <= 23 then
	MOVF       FARG_display_hour_hour+0, 0
	SUBLW      23
	BTFSS      STATUS+0, 0
	GOTO       L__display_hour133
;JJYClock.mbas,336 :: 		Lcd_Chr(1,10, ( hour /   10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_hour_hour+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,337 :: 		Lcd_Chr(1,11, ( hour mod 10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      11
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_hour_hour+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_hour134
;JJYClock.mbas,338 :: 		else
L__display_hour133:
;JJYClock.mbas,339 :: 		Lcd_Out(1,10, "ee" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      101
	MOVWF      ?LocalText_display_hour+0
	MOVLW      101
	MOVWF      ?LocalText_display_hour+1
	CLRF       ?LocalText_display_hour+2
	MOVLW      ?LocalText_display_hour+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,340 :: 		end if
L__display_hour134:
;JJYClock.mbas,341 :: 		end sub
L_end_display_hour:
	RETURN
; end of _display_hour

_display_date:

;JJYClock.mbas,346 :: 		sub procedure display_date( dim date as byte )
;JJYClock.mbas,347 :: 		Lcd_Out(1,4, "--/" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      45
	MOVWF      ?LocalText_display_date+0
	MOVLW      45
	MOVWF      ?LocalText_display_date+1
	MOVLW      47
	MOVWF      ?LocalText_display_date+2
	CLRF       ?LocalText_display_date+3
	MOVLW      ?LocalText_display_date+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,348 :: 		if date <= 31 then
	MOVF       FARG_display_date_date+0, 0
	SUBLW      31
	BTFSS      STATUS+0, 0
	GOTO       L__display_date137
;JJYClock.mbas,349 :: 		Lcd_Chr(1,7, ( date /   10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_date_date+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,350 :: 		Lcd_Chr(1,8, ( date mod 10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_date_date+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_date138
;JJYClock.mbas,351 :: 		else
L__display_date137:
;JJYClock.mbas,352 :: 		Lcd_Out(1,7, "ee" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      101
	MOVWF      ?LocalText_display_date+0
	MOVLW      101
	MOVWF      ?LocalText_display_date+1
	CLRF       ?LocalText_display_date+2
	MOVLW      ?LocalText_display_date+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,353 :: 		end if
L__display_date138:
;JJYClock.mbas,354 :: 		end sub
L_end_display_date:
	RETURN
; end of _display_date

_display_month:

;JJYClock.mbas,359 :: 		sub procedure display_month( dim month as byte )
;JJYClock.mbas,360 :: 		Lcd_Out(1,1, "--/" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      45
	MOVWF      ?LocalText_display_month+0
	MOVLW      45
	MOVWF      ?LocalText_display_month+1
	MOVLW      47
	MOVWF      ?LocalText_display_month+2
	CLRF       ?LocalText_display_month+3
	MOVLW      ?LocalText_display_month+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,361 :: 		if month <= 12 then
	MOVF       FARG_display_month_month+0, 0
	SUBLW      12
	BTFSS      STATUS+0, 0
	GOTO       L__display_month141
;JJYClock.mbas,362 :: 		Lcd_Chr(1,4, ( month /   10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_month_month+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,363 :: 		Lcd_Chr(1,5, ( month mod 10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      5
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_month_month+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_month142
;JJYClock.mbas,364 :: 		else
L__display_month141:
;JJYClock.mbas,365 :: 		Lcd_Out(1,4, "ee" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      101
	MOVWF      ?LocalText_display_month+0
	MOVLW      101
	MOVWF      ?LocalText_display_month+1
	CLRF       ?LocalText_display_month+2
	MOVLW      ?LocalText_display_month+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,366 :: 		end if
L__display_month142:
;JJYClock.mbas,367 :: 		end sub
L_end_display_month:
	RETURN
; end of _display_month

_display_year:

;JJYClock.mbas,372 :: 		sub procedure display_year( dim year as byte )
;JJYClock.mbas,373 :: 		Lcd_Chr(1,16, "-" )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      45
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,374 :: 		if year = 0 then
	MOVF       FARG_display_year_year+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__display_year145
;JJYClock.mbas,375 :: 		Lcd_Out(1,1,"??" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      63
	MOVWF      ?LocalText_display_year+0
	MOVLW      63
	MOVWF      ?LocalText_display_year+1
	CLRF       ?LocalText_display_year+2
	MOVLW      ?LocalText_display_year+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
	GOTO       L__display_year146
;JJYClock.mbas,376 :: 		else if year <= 99 then
L__display_year145:
	MOVF       FARG_display_year_year+0, 0
	SUBLW      99
	BTFSS      STATUS+0, 0
	GOTO       L__display_year148
;JJYClock.mbas,377 :: 		Lcd_Chr(1,1, ( year /   10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_year_year+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,378 :: 		Lcd_Chr(1,2, ( year mod 10 ) + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_display_year_year+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVLW      48
	ADDWF      R0+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_year149
;JJYClock.mbas,379 :: 		else
L__display_year148:
;JJYClock.mbas,380 :: 		Lcd_Out(1,1,"ee" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      101
	MOVWF      ?LocalText_display_year+0
	MOVLW      101
	MOVWF      ?LocalText_display_year+1
	CLRF       ?LocalText_display_year+2
	MOVLW      ?LocalText_display_year+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,381 :: 		end if end if
L__display_year149:
L__display_year146:
;JJYClock.mbas,382 :: 		end sub
L_end_display_year:
	RETURN
; end of _display_year

_display_day:

;JJYClock.mbas,387 :: 		sub procedure display_day( dim day as byte )
;JJYClock.mbas,388 :: 		Lcd_Out(1,13, "-- " )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      13
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      45
	MOVWF      ?LocalText_display_day+0
	MOVLW      45
	MOVWF      ?LocalText_display_day+1
	MOVLW      32
	MOVWF      ?LocalText_display_day+2
	CLRF       ?LocalText_display_day+3
	MOVLW      ?LocalText_display_day+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,389 :: 		if day <= 7 then
	MOVF       FARG_display_day_day+0, 0
	SUBLW      7
	BTFSS      STATUS+0, 0
	GOTO       L__display_day152
;JJYClock.mbas,390 :: 		Lcd_Chr(1,16, day + 0x30 )
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      FARG_display_day_day+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_day153
;JJYClock.mbas,391 :: 		else
L__display_day152:
;JJYClock.mbas,392 :: 		Lcd_Out(1,16,"e" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      101
	MOVWF      ?LocalText_display_day+0
	CLRF       ?LocalText_display_day+1
	MOVLW      ?LocalText_display_day+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,393 :: 		end if
L__display_day153:
;JJYClock.mbas,394 :: 		end sub
L_end_display_day:
	RETURN
; end of _display_day

_error_check_zero:

;JJYClock.mbas,401 :: 		const zero_table as byte[12] = ( 4, 10, 11, 14, 20, 21, 24, 34, 35, 56, 57, 58 )
;JJYClock.mbas,404 :: 		for index = 0 to 11
	CLRF       error_check_zero_index+0
L__error_check_zero156:
;JJYClock.mbas,405 :: 		if time_code[zero_table[index]] <> 0 then
	MOVF       error_check_zero_index+0, 0
	ADDLW      error_check_zero_zero_table+0
	MOVWF      R0+0
	MOVLW      hi_addr(error_check_zero_zero_table+0)
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      ___DoICPAddr+0
	MOVF       R0+1, 0
	MOVWF      ___DoICPAddr+1
	CALL       _____DoICP+0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__error_check_zero161
;JJYClock.mbas,406 :: 		Lcd_Out(1,15, "*" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      15
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      42
	MOVWF      ?LocalText_error_check_zero+0
	CLRF       ?LocalText_error_check_zero+1
	MOVLW      ?LocalText_error_check_zero+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,407 :: 		result = false
	CLRF       error_check_zero_local_result+0
;JJYClock.mbas,408 :: 		exit
	GOTO       L_end__error_check_zero
L__error_check_zero161:
;JJYClock.mbas,410 :: 		next index
	MOVF       error_check_zero_index+0, 0
	XORLW      11
	BTFSC      STATUS+0, 2
	GOTO       L__error_check_zero159
	INCF       error_check_zero_index+0, 1
	GOTO       L__error_check_zero156
L__error_check_zero159:
;JJYClock.mbas,412 :: 		result = true
	MOVLW      255
	MOVWF      error_check_zero_local_result+0
;JJYClock.mbas,413 :: 		end sub
L_end__error_check_zero:
	MOVF       error_check_zero_local_result+0, 0
	MOVWF      R0+0
L_end_error_check_zero:
	RETURN
; end of _error_check_zero

_error_check_parity:

;JJYClock.mbas,419 :: 		dim parity  as byte
;JJYClock.mbas,423 :: 		time_code[13] +
	MOVF       _time_code+13, 0
	ADDWF      _time_code+12, 0
	MOVWF      R0+0
;JJYClock.mbas,424 :: 		time_code[15] +
	MOVF       _time_code+15, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,425 :: 		time_code[16] +
	MOVF       _time_code+16, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,426 :: 		time_code[17] +
	MOVF       _time_code+17, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,427 :: 		time_code[18]) mod 2
	MOVF       _time_code+18, 0
	ADDWF      R0+0, 1
	MOVLW      1
	ANDWF      R0+0, 0
	MOVWF      R1+0
;JJYClock.mbas,428 :: 		if time_code[PA1_INDEX] <> parity then
	MOVF       _time_code+36, 0
	XORWF      R1+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__error_check_parity165
;JJYClock.mbas,429 :: 		Lcd_Out(1,7, "**" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      7
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      42
	MOVWF      ?LocalText_error_check_parity+0
	MOVLW      42
	MOVWF      ?LocalText_error_check_parity+1
	CLRF       ?LocalText_error_check_parity+2
	MOVLW      ?LocalText_error_check_parity+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,430 :: 		result = false
	CLRF       error_check_parity_local_result+0
;JJYClock.mbas,431 :: 		exit
	GOTO       L_end__error_check_parity
L__error_check_parity165:
;JJYClock.mbas,434 :: 		time_code[2] +
	MOVF       _time_code+2, 0
	ADDWF      _time_code+1, 0
	MOVWF      R0+0
;JJYClock.mbas,435 :: 		time_code[3] +
	MOVF       _time_code+3, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,436 :: 		time_code[5] +
	MOVF       _time_code+5, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,437 :: 		time_code[6] +
	MOVF       _time_code+6, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,438 :: 		time_code[7] +
	MOVF       _time_code+7, 0
	ADDWF      R0+0, 1
;JJYClock.mbas,439 :: 		time_code[8]) mod 2
	MOVF       _time_code+8, 0
	ADDWF      R0+0, 1
	MOVLW      1
	ANDWF      R0+0, 0
	MOVWF      R1+0
;JJYClock.mbas,440 :: 		if time_code[PA2_INDEX] <> parity then
	MOVF       _time_code+37, 0
	XORWF      R1+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__error_check_parity168
;JJYClock.mbas,441 :: 		Lcd_Out(1,10, "**" )
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      42
	MOVWF      ?LocalText_error_check_parity+0
	MOVLW      42
	MOVWF      ?LocalText_error_check_parity+1
	CLRF       ?LocalText_error_check_parity+2
	MOVLW      ?LocalText_error_check_parity+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,442 :: 		result = false
	CLRF       error_check_parity_local_result+0
;JJYClock.mbas,443 :: 		exit
	GOTO       L_end__error_check_parity
L__error_check_parity168:
;JJYClock.mbas,445 :: 		result = true
	MOVLW      255
	MOVWF      error_check_parity_local_result+0
;JJYClock.mbas,446 :: 		end sub
L_end__error_check_parity:
	MOVF       error_check_parity_local_result+0, 0
	MOVWF      R0+0
L_end_error_check_parity:
	RETURN
; end of _error_check_parity

_display_seconds:

;JJYClock.mbas,454 :: 		dim dig1   as byte
;JJYClock.mbas,456 :: 		dig1   = sec mod 10
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       FARG_display_seconds_sec+0, 0
	MOVWF      R0+0
	MOVF       FARG_display_seconds_sec+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      display_seconds_dig1+0
;JJYClock.mbas,457 :: 		sec = sec / 10
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       FARG_display_seconds_sec+0, 0
	MOVWF      R0+0
	MOVF       FARG_display_seconds_sec+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__display_seconds+0
	MOVF       R0+1, 0
	MOVWF      FLOC__display_seconds+1
	MOVF       FLOC__display_seconds+0, 0
	MOVWF      FARG_display_seconds_sec+0
	MOVF       FLOC__display_seconds+1, 0
	MOVWF      FARG_display_seconds_sec+1
;JJYClock.mbas,458 :: 		dig10  = sec mod 10
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       FLOC__display_seconds+0, 0
	MOVWF      R0+0
	MOVF       FLOC__display_seconds+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      display_seconds_dig10+0
;JJYClock.mbas,459 :: 		sec = sec / 10
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       FLOC__display_seconds+0, 0
	MOVWF      R0+0
	MOVF       FLOC__display_seconds+1, 0
	MOVWF      R0+1
	CALL       _Div_16x16_U+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_seconds_sec+0
	MOVF       R0+1, 0
	MOVWF      FARG_display_seconds_sec+1
;JJYClock.mbas,460 :: 		dig100 = sec mod 10
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CALL       _Div_16x16_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R0+0, 0
	MOVWF      display_seconds_dig100+0
;JJYClock.mbas,462 :: 		if dig100 <> 0 then
	MOVF       R0+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__display_seconds172
;JJYClock.mbas,463 :: 		Lcd_chr( 2, 14, dig100 + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      14
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      display_seconds_dig100+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,464 :: 		Lcd_chr( 2, 15, dig10  + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      15
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      display_seconds_dig10+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,465 :: 		Lcd_chr( 2, 16, dig1   + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      display_seconds_dig1+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_seconds173
;JJYClock.mbas,466 :: 		else
L__display_seconds172:
;JJYClock.mbas,467 :: 		if dig10 <> 0 then
	MOVF       display_seconds_dig10+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__display_seconds175
;JJYClock.mbas,468 :: 		Lcd_chr( 2, 14, " " )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      14
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      32
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,469 :: 		Lcd_chr( 2, 15, dig10  + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      15
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      display_seconds_dig10+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,470 :: 		Lcd_chr( 2, 16, dig1   + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      display_seconds_dig1+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_seconds176
;JJYClock.mbas,471 :: 		else
L__display_seconds175:
;JJYClock.mbas,472 :: 		Lcd_chr( 2, 14, " " )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      14
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      32
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,473 :: 		Lcd_chr( 2, 15, " " )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      15
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      32
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,474 :: 		Lcd_chr( 2, 16, dig1   + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      display_seconds_dig1+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,475 :: 		end if
L__display_seconds176:
;JJYClock.mbas,476 :: 		end if
L__display_seconds173:
;JJYClock.mbas,477 :: 		end sub
L_end_display_seconds:
	RETURN
; end of _display_seconds

_display_date_time:

;JJYClock.mbas,484 :: 		dim minutes as byte
;JJYClock.mbas,486 :: 		all_ok = true
	MOVLW      255
	MOVWF      display_date_time_all_ok+0
;JJYClock.mbas,488 :: 		case 1 if time_code_index = 9 then       ' Minutes
	MOVF       FARG_display_date_time_mark_count+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time181
	MOVF       FARG_display_date_time_time_code_index+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time183
;JJYClock.mbas,489 :: 		MIN_LED = 1
	BSF        RC2_bit+0, BitPos(RC2_bit+0)
	GOTO       L__display_date_time184
;JJYClock.mbas,490 :: 		else
L__display_date_time183:
;JJYClock.mbas,491 :: 		all_ok = false
	CLRF       display_date_time_all_ok+0
;JJYClock.mbas,492 :: 		end if
L__display_date_time184:
;JJYClock.mbas,493 :: 		if all_ok then
	MOVF       display_date_time_all_ok+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time186
;JJYClock.mbas,494 :: 		display_minutes( decode_minutes() )
	CALL       _decode_minutes+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_minutes_minutes+0
	CALL       _display_minutes+0
L__display_date_time186:
;JJYClock.mbas,495 :: 		end if
	GOTO       L__display_date_time178
L__display_date_time181:
;JJYClock.mbas,496 :: 		case 2 if time_code_index = 19 then      ' Hours
	MOVF       FARG_display_date_time_mark_count+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time190
	MOVF       FARG_display_date_time_time_code_index+0, 0
	XORLW      19
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time192
;JJYClock.mbas,497 :: 		HOUR_LED  = 1
	BSF        RC3_bit+0, BitPos(RC3_bit+0)
	GOTO       L__display_date_time193
;JJYClock.mbas,498 :: 		else
L__display_date_time192:
;JJYClock.mbas,499 :: 		all_ok = false
	CLRF       display_date_time_all_ok+0
;JJYClock.mbas,500 :: 		end if
L__display_date_time193:
;JJYClock.mbas,501 :: 		if all_ok then
	MOVF       display_date_time_all_ok+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time195
;JJYClock.mbas,502 :: 		display_hour( decode_hours() )
	CALL       _decode_hours+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_hour_hour+0
	CALL       _display_hour+0
L__display_date_time195:
;JJYClock.mbas,503 :: 		end if
	GOTO       L__display_date_time178
L__display_date_time190:
;JJYClock.mbas,504 :: 		case 3 if time_code_index = 29 then
	MOVF       FARG_display_date_time_mark_count+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time199
	MOVF       FARG_display_date_time_time_code_index+0, 0
	XORLW      29
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time201
;JJYClock.mbas,505 :: 		MONTH_LED = 1
	BSF        RC5_bit+0, BitPos(RC5_bit+0)
	GOTO       L__display_date_time202
;JJYClock.mbas,506 :: 		else
L__display_date_time201:
;JJYClock.mbas,507 :: 		all_ok = false
	CLRF       display_date_time_all_ok+0
;JJYClock.mbas,508 :: 		end if
L__display_date_time202:
	GOTO       L__display_date_time178
L__display_date_time199:
;JJYClock.mbas,509 :: 		case 4 if time_code_index = 39 then     ' Month & Date
	MOVF       FARG_display_date_time_mark_count+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time205
	MOVF       FARG_display_date_time_time_code_index+0, 0
	XORLW      39
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time207
;JJYClock.mbas,510 :: 		DATE_LED  = 1
	BSF        RC4_bit+0, BitPos(RC4_bit+0)
	GOTO       L__display_date_time208
;JJYClock.mbas,511 :: 		else
L__display_date_time207:
;JJYClock.mbas,512 :: 		all_ok = false
	CLRF       display_date_time_all_ok+0
;JJYClock.mbas,513 :: 		end if
L__display_date_time208:
;JJYClock.mbas,514 :: 		if all_ok then
	MOVF       display_date_time_all_ok+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time210
;JJYClock.mbas,515 :: 		display_date( decode_date(false) )
	CLRF       FARG_decode_date_leapyear+0
	CALL       _decode_date+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_date_date+0
	CALL       _display_date+0
;JJYClock.mbas,516 :: 		display_month( decode_month(false) )
	CLRF       FARG_decode_month_leapyear+0
	CALL       _decode_month+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_month_month+0
	CALL       _display_month+0
L__display_date_time210:
;JJYClock.mbas,517 :: 		end if
	GOTO       L__display_date_time178
L__display_date_time205:
;JJYClock.mbas,518 :: 		case 5 if time_code_index = 49 then     ' Year
	MOVF       FARG_display_date_time_mark_count+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time214
	MOVF       FARG_display_date_time_time_code_index+0, 0
	XORLW      49
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time216
;JJYClock.mbas,519 :: 		ALM1_LED  = 1
	BSF        RA2_bit+0, BitPos(RA2_bit+0)
	GOTO       L__display_date_time217
;JJYClock.mbas,520 :: 		else
L__display_date_time216:
;JJYClock.mbas,521 :: 		all_ok = false
	CLRF       display_date_time_all_ok+0
;JJYClock.mbas,522 :: 		end if
L__display_date_time217:
;JJYClock.mbas,523 :: 		if all_ok then
	MOVF       display_date_time_all_ok+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time219
;JJYClock.mbas,524 :: 		minutes = decode_minutes()
	CALL       _decode_minutes+0
;JJYClock.mbas,525 :: 		if ((minutes <> 15) and (minutes <> 45)) then
	MOVF       R0+0, 0
	XORLW      15
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVF       R0+0, 0
	XORLW      45
	MOVLW      255
	BTFSC      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ANDWF      R2+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time222
;JJYClock.mbas,526 :: 		display_date( decode_date(is_leapyear(decode_year())) )
	CALL       _decode_year+0
	MOVF       R0+0, 0
	MOVWF      FARG_is_leapyear_year+0
	CALL       _is_leapyear+0
	MOVF       R0+0, 0
	MOVWF      FARG_decode_date_leapyear+0
	CALL       _decode_date+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_date_date+0
	CALL       _display_date+0
;JJYClock.mbas,527 :: 		display_month( decode_month(is_leapyear(decode_year())) )
	CALL       _decode_year+0
	MOVF       R0+0, 0
	MOVWF      FARG_is_leapyear_year+0
	CALL       _is_leapyear+0
	MOVF       R0+0, 0
	MOVWF      FARG_decode_month_leapyear+0
	CALL       _decode_month+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_month_month+0
	CALL       _display_month+0
L__display_date_time222:
;JJYClock.mbas,529 :: 		display_year( decode_year() )
	CALL       _decode_year+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_year_year+0
	CALL       _display_year+0
L__display_date_time219:
;JJYClock.mbas,530 :: 		end if
	GOTO       L__display_date_time178
L__display_date_time214:
;JJYClock.mbas,531 :: 		case 6 if time_code_index = 59 then    ' Day
	MOVF       FARG_display_date_time_mark_count+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time226
	MOVF       FARG_display_date_time_time_code_index+0, 0
	XORLW      59
	BTFSS      STATUS+0, 2
	GOTO       L__display_date_time228
	GOTO       L__display_date_time229
;JJYClock.mbas,533 :: 		else
L__display_date_time228:
;JJYClock.mbas,534 :: 		all_ok = false
	CLRF       display_date_time_all_ok+0
;JJYClock.mbas,535 :: 		end if
L__display_date_time229:
;JJYClock.mbas,536 :: 		if all_ok then
	MOVF       display_date_time_all_ok+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time231
;JJYClock.mbas,537 :: 		minutes = decode_minutes()
	CALL       _decode_minutes+0
;JJYClock.mbas,538 :: 		if ((minutes = 15) or (minutes = 45)) then
	MOVF       R0+0, 0
	XORLW      15
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVF       R0+0, 0
	XORLW      45
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	IORWF      R2+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__display_date_time234
;JJYClock.mbas,539 :: 		Lcd_Chr(1,16,"?")
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      16
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      63
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__display_date_time235
;JJYClock.mbas,540 :: 		else
L__display_date_time234:
;JJYClock.mbas,541 :: 		display_day( decode_day() )
	CALL       _decode_day+0
	MOVF       R0+0, 0
	MOVWF      FARG_display_day_day+0
	CALL       _display_day+0
;JJYClock.mbas,542 :: 		end if
L__display_date_time235:
L__display_date_time231:
;JJYClock.mbas,543 :: 		end if
	GOTO       L__display_date_time178
L__display_date_time226:
L__display_date_time178:
;JJYClock.mbas,545 :: 		result = all_ok
	MOVF       display_date_time_all_ok+0, 0
	MOVWF      display_date_time_local_result+0
;JJYClock.mbas,546 :: 		end sub
	MOVF       display_date_time_local_result+0, 0
	MOVWF      R0+0
L_end_display_date_time:
	RETURN
; end of _display_date_time

_main:

;JJYClock.mbas,563 :: 		dim exit_disable_time_zone as boolean
;JJYClock.mbas,565 :: 		JJY_input_tris = PORT_INPUT
	BSF        TRISA4_bit+0, BitPos(TRISA4_bit+0)
;JJYClock.mbas,566 :: 		TCO_LED_tris   = PORT_OUTPUT
	BCF        TRISC0_bit+0, BitPos(TRISC0_bit+0)
;JJYClock.mbas,567 :: 		NG_LED_tris    = PORT_OUTPUT
	BCF        TRISC1_bit+0, BitPos(TRISC1_bit+0)
;JJYClock.mbas,568 :: 		MIN_LED_tris   = PORT_OUTPUT
	BCF        TRISC2_bit+0, BitPos(TRISC2_bit+0)
;JJYClock.mbas,569 :: 		HOUR_LED_tris  = PORT_OUTPUT
	BCF        TRISC3_bit+0, BitPos(TRISC3_bit+0)
;JJYClock.mbas,570 :: 		DATE_LED_tris  = PORT_OUTPUT
	BCF        TRISC4_bit+0, BitPos(TRISC4_bit+0)
;JJYClock.mbas,571 :: 		MONTH_LED_tris = PORT_OUTPUT
	BCF        TRISC5_bit+0, BitPos(TRISC5_bit+0)
;JJYClock.mbas,572 :: 		ALM1_LED_tris  = PORT_OUTPUT
	BCF        TRISA2_bit+0, BitPos(TRISA2_bit+0)
;JJYClock.mbas,573 :: 		ALM2_LED_tris  = PORT_OUTPUT
	BCF        TRISA5_bit+0, BitPos(TRISA5_bit+0)
;JJYClock.mbas,576 :: 		PCFG3_bit = 0
	BCF        PCFG3_bit+0, BitPos(PCFG3_bit+0)
;JJYClock.mbas,577 :: 		PCFG2_bit = 1
	BSF        PCFG2_bit+0, BitPos(PCFG2_bit+0)
;JJYClock.mbas,578 :: 		PCFG1_bit = 1
	BSF        PCFG1_bit+0, BitPos(PCFG1_bit+0)
;JJYClock.mbas,580 :: 		CCP1CON = 0
	CLRF       CCP1CON+0
;JJYClock.mbas,582 :: 		NG_LED    = 0
	BCF        RC1_bit+0, BitPos(RC1_bit+0)
;JJYClock.mbas,583 :: 		MIN_LED   = 0
	BCF        RC2_bit+0, BitPos(RC2_bit+0)
;JJYClock.mbas,584 :: 		HOUR_LED  = 0
	BCF        RC3_bit+0, BitPos(RC3_bit+0)
;JJYClock.mbas,585 :: 		MONTH_LED = 0
	BCF        RC5_bit+0, BitPos(RC5_bit+0)
;JJYClock.mbas,586 :: 		DATE_LED  = 0
	BCF        RC4_bit+0, BitPos(RC4_bit+0)
;JJYClock.mbas,587 :: 		ALM1_LED  = 0
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
;JJYClock.mbas,588 :: 		ALM2_LED  = 0
	BCF        RA5_bit+0, BitPos(RA5_bit+0)
;JJYClock.mbas,590 :: 		Lcd_Init()                     ' Initialize Lcd
	CALL       _Lcd_Init+0
;JJYClock.mbas,591 :: 		Lcd_Cmd(_LCD_CLEAR)            ' Clear display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;JJYClock.mbas,592 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)       ' Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;JJYClock.mbas,595 :: 		TOUTPS3_bit = 1 ' Postscaler = 1:10
	BSF        TOUTPS3_bit+0, BitPos(TOUTPS3_bit+0)
;JJYClock.mbas,596 :: 		TOUTPS2_bit = 0
	BCF        TOUTPS2_bit+0, BitPos(TOUTPS2_bit+0)
;JJYClock.mbas,597 :: 		TOUTPS1_bit = 0
	BCF        TOUTPS1_bit+0, BitPos(TOUTPS1_bit+0)
;JJYClock.mbas,598 :: 		TOUTPS0_bit = 1
	BSF        TOUTPS0_bit+0, BitPos(TOUTPS0_bit+0)
;JJYClock.mbas,599 :: 		T2CKPS1_bit = 0 ' Prescaler = 1:4
	BCF        T2CKPS1_bit+0, BitPos(T2CKPS1_bit+0)
;JJYClock.mbas,600 :: 		T2CKPS0_bit = 1
	BSF        T2CKPS0_bit+0, BitPos(T2CKPS0_bit+0)
;JJYClock.mbas,601 :: 		PR2 = PR2_1MSEC  ' 1[msec] period
	MOVLW      122
	MOVWF      PR2+0
;JJYClock.mbas,602 :: 		TMR2ON_bit = true
	BSF        TMR2ON_bit+0, BitPos(TMR2ON_bit+0)
;JJYClock.mbas,603 :: 		TMR2IE_bit = true ' TMR2 interupt enable
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;JJYClock.mbas,605 :: 		msec    = 0
	CLRF       _msec+0
	CLRF       _msec+1
;JJYClock.mbas,606 :: 		seconds = 0
	CLRF       _seconds+0
	CLRF       _seconds+1
;JJYClock.mbas,607 :: 		seconds_reset = false
	CLRF       _seconds_reset+0
;JJYClock.mbas,610 :: 		PEIE_bit = true
	BSF        PEIE_bit+0, BitPos(PEIE_bit+0)
;JJYClock.mbas,611 :: 		GIE_bit  = true  ' interrupt enable
	BSF        GIE_bit+0, BitPos(GIE_bit+0)
;JJYClock.mbas,613 :: 		signal_prev     = 0
	CLRF       main_signal_prev+0
;JJYClock.mbas,614 :: 		time_code_index = 0
	CLRF       main_time_code_index+0
;JJYClock.mbas,615 :: 		lcd_col         = 0
	CLRF       main_lcd_col+0
;JJYClock.mbas,616 :: 		prev_jjy_code   = 2
	MOVLW      2
	MOVWF      main_prev_jjy_code+0
;JJYClock.mbas,617 :: 		mark_count      = 0
	CLRF       main_mark_count+0
;JJYClock.mbas,618 :: 		prev_seconds    = 0
	CLRF       main_prev_seconds+0
;JJYClock.mbas,619 :: 		disable_time_zone = false
	CLRF       _disable_time_zone+0
;JJYClock.mbas,620 :: 		exit_disable_time_zone = false
	CLRF       main_exit_disable_time_zone+0
;JJYClock.mbas,621 :: 		all_ok = false
	CLRF       main_all_ok+0
;JJYClock.mbas,622 :: 		while true
L__main238:
;JJYClock.mbas,623 :: 		signal_curr = JJY_INPUT
	MOVLW      0
	BTFSC      RA4_bit+0, BitPos(RA4_bit+0)
	MOVLW      1
	MOVWF      main_signal_curr+0
;JJYClock.mbas,625 :: 		if signal_curr = 1 then
	MOVF       main_signal_curr+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main243
;JJYClock.mbas,626 :: 		TCO_LED  = 0
	BCF        RC0_bit+0, BitPos(RC0_bit+0)
	GOTO       L__main244
;JJYClock.mbas,627 :: 		else
L__main243:
;JJYClock.mbas,628 :: 		TCO_LED  = 1
	BSF        RC0_bit+0, BitPos(RC0_bit+0)
;JJYClock.mbas,629 :: 		end if
L__main244:
;JJYClock.mbas,630 :: 		if pulse_width < 100 then
	MOVLW      0
	SUBWF      _pulse_width+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main347
	MOVLW      100
	SUBWF      _pulse_width+0, 0
L__main347:
	BTFSC      STATUS+0, 0
	GOTO       L__main246
;JJYClock.mbas,631 :: 		ALM2_LED = 1
	BSF        RA5_bit+0, BitPos(RA5_bit+0)
	GOTO       L__main247
;JJYClock.mbas,632 :: 		else
L__main246:
;JJYClock.mbas,633 :: 		ALM2_LED = 0
	BCF        RA5_bit+0, BitPos(RA5_bit+0)
;JJYClock.mbas,634 :: 		end if
L__main247:
;JJYClock.mbas,636 :: 		if prev_seconds <> seconds then
	MOVLW      0
	XORWF      _seconds+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main348
	MOVF       _seconds+0, 0
	XORWF      main_prev_seconds+0, 0
L__main348:
	BTFSC      STATUS+0, 2
	GOTO       L__main249
;JJYClock.mbas,637 :: 		display_seconds(seconds)
	MOVF       _seconds+0, 0
	MOVWF      FARG_display_seconds_sec+0
	MOVF       _seconds+1, 0
	MOVWF      FARG_display_seconds_sec+1
	CALL       _display_seconds+0
;JJYClock.mbas,638 :: 		prev_seconds = seconds
	MOVF       _seconds+0, 0
	MOVWF      main_prev_seconds+0
L__main249:
;JJYClock.mbas,641 :: 		if disable_time_zone then
	MOVF       _disable_time_zone+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main252
;JJYClock.mbas,642 :: 		if disable_msec < MORSE_DISABLE_TIME then
	MOVLW      40
	SUBWF      _disable_msec+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main349
	MOVLW      160
	SUBWF      _disable_msec+0, 0
L__main349:
	BTFSC      STATUS+0, 0
	GOTO       L__main255
;JJYClock.mbas,643 :: 		continue  ' goto top of the while loop
	GOTO       L__main238
;JJYClock.mbas,644 :: 		else
L__main255:
;JJYClock.mbas,645 :: 		mark_count = 5
	MOVLW      5
	MOVWF      main_mark_count+0
;JJYClock.mbas,646 :: 		disable_time_zone = false
	CLRF       _disable_time_zone+0
;JJYClock.mbas,647 :: 		exit_disable_time_zone = true
	MOVLW      255
	MOVWF      main_exit_disable_time_zone+0
;JJYClock.mbas,648 :: 		end if
L__main252:
;JJYClock.mbas,651 :: 		if all_ok = false then
	MOVF       main_all_ok+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main258
;JJYClock.mbas,652 :: 		NG_LED    = 1
	BSF        RC1_bit+0, BitPos(RC1_bit+0)
L__main258:
;JJYClock.mbas,655 :: 		if signal_curr <> signal_prev then
	MOVF       main_signal_curr+0, 0
	XORWF      main_signal_prev+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main261
;JJYClock.mbas,656 :: 		if signal_curr = 0 then ' falling edge  ---------------------------------
	MOVF       main_signal_curr+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main264
;JJYClock.mbas,658 :: 		if exit_disable_time_zone = false then
	MOVF       main_exit_disable_time_zone+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main267
;JJYClock.mbas,659 :: 		if (pulse_width < 950) or ( 1050 < pulse_width) then  ' error not 1sec period
	MOVLW      3
	SUBWF      _pulse_width+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main350
	MOVLW      182
	SUBWF      _pulse_width+0, 0
L__main350:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
	MOVF       _pulse_width+1, 0
	SUBLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__main351
	MOVF       _pulse_width+0, 0
	SUBLW      26
L__main351:
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main270
;JJYClock.mbas,660 :: 		jjy_code = "E"       ' error
	MOVLW      69
	MOVWF      main_jjy_code+0
;JJYClock.mbas,662 :: 		all_ok = false
	CLRF       main_all_ok+0
L__main270:
;JJYClock.mbas,663 :: 		end if
	GOTO       L__main268
;JJYClock.mbas,664 :: 		else
L__main267:
;JJYClock.mbas,665 :: 		exit_disable_time_zone = false
	CLRF       main_exit_disable_time_zone+0
;JJYClock.mbas,666 :: 		end if
L__main268:
;JJYClock.mbas,667 :: 		pulse_width_reset = true
	MOVLW      255
	MOVWF      _pulse_width_reset+0
;JJYClock.mbas,669 :: 		if jjy_code = "P" then
	MOVF       main_jjy_code+0, 0
	XORLW      80
	BTFSS      STATUS+0, 2
	GOTO       L__main273
;JJYClock.mbas,670 :: 		Lcd_Out(2,1,"             ")
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      32
	MOVWF      ?LocalText_main+0
	MOVLW      32
	MOVWF      ?LocalText_main+1
	MOVLW      32
	MOVWF      ?LocalText_main+2
	MOVLW      32
	MOVWF      ?LocalText_main+3
	MOVLW      32
	MOVWF      ?LocalText_main+4
	MOVLW      32
	MOVWF      ?LocalText_main+5
	MOVLW      32
	MOVWF      ?LocalText_main+6
	MOVLW      32
	MOVWF      ?LocalText_main+7
	MOVLW      32
	MOVWF      ?LocalText_main+8
	MOVLW      32
	MOVWF      ?LocalText_main+9
	MOVLW      32
	MOVWF      ?LocalText_main+10
	MOVLW      32
	MOVWF      ?LocalText_main+11
	MOVLW      32
	MOVWF      ?LocalText_main+12
	CLRF       ?LocalText_main+13
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,671 :: 		lcd_col = 1
	MOVLW      1
	MOVWF      main_lcd_col+0
;JJYClock.mbas,672 :: 		if prev_jjy_code = "P" then '--- find Marker -----------
	MOVF       main_prev_jjy_code+0, 0
	XORLW      80
	BTFSS      STATUS+0, 2
	GOTO       L__main276
;JJYClock.mbas,673 :: 		seconds_reset = true
	MOVLW      255
	MOVWF      _seconds_reset+0
;JJYClock.mbas,674 :: 		mark_count = 0
	CLRF       main_mark_count+0
;JJYClock.mbas,675 :: 		time_code_index = 0
	CLRF       main_time_code_index+0
;JJYClock.mbas,676 :: 		NG_LED    = 0
	BCF        RC1_bit+0, BitPos(RC1_bit+0)
;JJYClock.mbas,677 :: 		MIN_LED   = 0
	BCF        RC2_bit+0, BitPos(RC2_bit+0)
;JJYClock.mbas,678 :: 		HOUR_LED  = 0
	BCF        RC3_bit+0, BitPos(RC3_bit+0)
;JJYClock.mbas,679 :: 		MONTH_LED = 0
	BCF        RC5_bit+0, BitPos(RC5_bit+0)
;JJYClock.mbas,680 :: 		DATE_LED  = 0
	BCF        RC4_bit+0, BitPos(RC4_bit+0)
;JJYClock.mbas,681 :: 		ALM1_LED  = 0
	BCF        RA2_bit+0, BitPos(RA2_bit+0)
;JJYClock.mbas,682 :: 		all_ok = true
	MOVLW      255
	MOVWF      main_all_ok+0
	GOTO       L__main277
;JJYClock.mbas,683 :: 		else   '--- find position marker P0 to P5 ---------
L__main276:
;JJYClock.mbas,684 :: 		if all_ok then
	MOVF       main_all_ok+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main279
;JJYClock.mbas,685 :: 		all_ok = display_date_time( mark_count, time_code_index )
	MOVF       main_mark_count+0, 0
	MOVWF      FARG_display_date_time_mark_count+0
	MOVF       main_time_code_index+0, 0
	MOVWF      FARG_display_date_time_time_code_index+0
	CALL       _display_date_time+0
	MOVF       R0+0, 0
	MOVWF      main_all_ok+0
L__main279:
;JJYClock.mbas,687 :: 		end if
L__main277:
L__main273:
;JJYClock.mbas,690 :: 		prev_jjy_code = jjy_code
	MOVF       main_jjy_code+0, 0
	MOVWF      main_prev_jjy_code+0
;JJYClock.mbas,691 :: 		time_code[time_code_index] = jjy_code
	MOVF       main_time_code_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	MOVF       main_jjy_code+0, 0
	MOVWF      INDF+0
;JJYClock.mbas,692 :: 		if time_code_index < 59 then
	MOVLW      59
	SUBWF      main_time_code_index+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main282
;JJYClock.mbas,693 :: 		time_code_index = time_code_index + 1
	INCF       main_time_code_index+0, 1
L__main282:
;JJYClock.mbas,696 :: 		if (time_code_index = 59) and all_ok  then
	MOVF       main_time_code_index+0, 0
	XORLW      59
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       main_all_ok+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main285
;JJYClock.mbas,697 :: 		all_ok = error_check_parity()
	CALL       _error_check_parity+0
	MOVF       R0+0, 0
	MOVWF      main_all_ok+0
;JJYClock.mbas,698 :: 		all_ok = error_check_zero()
	CALL       _error_check_zero+0
	MOVF       R0+0, 0
	MOVWF      main_all_ok+0
L__main285:
;JJYClock.mbas,701 :: 		if lcd_col = 14 then
	MOVF       main_lcd_col+0, 0
	XORLW      14
	BTFSS      STATUS+0, 2
	GOTO       L__main288
;JJYClock.mbas,702 :: 		Lcd_Out(2,1,"             ")
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      32
	MOVWF      ?LocalText_main+0
	MOVLW      32
	MOVWF      ?LocalText_main+1
	MOVLW      32
	MOVWF      ?LocalText_main+2
	MOVLW      32
	MOVWF      ?LocalText_main+3
	MOVLW      32
	MOVWF      ?LocalText_main+4
	MOVLW      32
	MOVWF      ?LocalText_main+5
	MOVLW      32
	MOVWF      ?LocalText_main+6
	MOVLW      32
	MOVWF      ?LocalText_main+7
	MOVLW      32
	MOVWF      ?LocalText_main+8
	MOVLW      32
	MOVWF      ?LocalText_main+9
	MOVLW      32
	MOVWF      ?LocalText_main+10
	MOVLW      32
	MOVWF      ?LocalText_main+11
	MOVLW      32
	MOVWF      ?LocalText_main+12
	CLRF       ?LocalText_main+13
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,703 :: 		lcd_col = 1
	MOVLW      1
	MOVWF      main_lcd_col+0
L__main288:
;JJYClock.mbas,705 :: 		if jjy_code <= 1 then
	MOVF       main_jjy_code+0, 0
	SUBLW      1
	BTFSS      STATUS+0, 0
	GOTO       L__main291
;JJYClock.mbas,706 :: 		Lcd_Chr( 2, lcd_col, jjy_code + 0x30 )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVF       main_lcd_col+0, 0
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      48
	ADDWF      main_jjy_code+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__main292
;JJYClock.mbas,707 :: 		else
L__main291:
;JJYClock.mbas,708 :: 		if (mark_count = 0) and (jjy_code = "P" )then
	MOVF       main_mark_count+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       main_jjy_code+0, 0
	XORLW      80
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main294
;JJYClock.mbas,709 :: 		Lcd_Chr( 2, 1, "M" )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVLW      77
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
	GOTO       L__main295
;JJYClock.mbas,710 :: 		else
L__main294:
;JJYClock.mbas,711 :: 		Lcd_Chr( 2, lcd_col, jjy_code )
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_Row+0
	MOVF       main_lcd_col+0, 0
	MOVWF      FARG_Lcd_Chr_Column+0
	MOVF       main_jjy_code+0, 0
	MOVWF      FARG_Lcd_Chr_Out_Char+0
	CALL       _Lcd_Chr+0
;JJYClock.mbas,712 :: 		end if
L__main295:
;JJYClock.mbas,713 :: 		end if
L__main292:
;JJYClock.mbas,714 :: 		lcd_col = lcd_col + 1
	INCF       main_lcd_col+0, 1
	GOTO       L__main265
;JJYClock.mbas,715 :: 		else ' rising edge -----------------------------------------------------
L__main264:
;JJYClock.mbas,716 :: 		if pulse_width < 350 then
	MOVLW      1
	SUBWF      _pulse_width+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main352
	MOVLW      94
	SUBWF      _pulse_width+0, 0
L__main352:
	BTFSC      STATUS+0, 0
	GOTO       L__main297
;JJYClock.mbas,717 :: 		jjy_code = "P"       ' 0.2sec pulse
	MOVLW      80
	MOVWF      main_jjy_code+0
;JJYClock.mbas,718 :: 		mark_count = mark_count + 1
	INCF       main_mark_count+0, 1
;JJYClock.mbas,719 :: 		minutes = decode_minutes()
	CALL       _decode_minutes+0
;JJYClock.mbas,720 :: 		if all_ok and ((minutes = 15) or (minutes = 45)) and  mark_count = 4 then
	MOVF       R0+0, 0
	XORLW      15
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
	MOVF       R0+0, 0
	XORLW      45
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	IORWF      R2+0, 0
	MOVWF      R0+0
	MOVF       main_all_ok+0, 0
	ANDWF      R0+0, 1
	MOVF       main_mark_count+0, 0
	ANDWF      R0+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__main300
;JJYClock.mbas,721 :: 		disable_msec = 0
	CLRF       _disable_msec+0
	CLRF       _disable_msec+1
;JJYClock.mbas,722 :: 		disable_time_zone = true
	MOVLW      255
	MOVWF      _disable_time_zone+0
;JJYClock.mbas,723 :: 		time_code[39] = jjy_code
	MOVF       main_jjy_code+0, 0
	MOVWF      _time_code+39
;JJYClock.mbas,724 :: 		lcd_out(2,1,"-SKIP SIGNAL-")
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      45
	MOVWF      ?LocalText_main+0
	MOVLW      83
	MOVWF      ?LocalText_main+1
	MOVLW      75
	MOVWF      ?LocalText_main+2
	MOVLW      73
	MOVWF      ?LocalText_main+3
	MOVLW      80
	MOVWF      ?LocalText_main+4
	MOVLW      32
	MOVWF      ?LocalText_main+5
	MOVLW      83
	MOVWF      ?LocalText_main+6
	MOVLW      73
	MOVWF      ?LocalText_main+7
	MOVLW      71
	MOVWF      ?LocalText_main+8
	MOVLW      78
	MOVWF      ?LocalText_main+9
	MOVLW      65
	MOVWF      ?LocalText_main+10
	MOVLW      76
	MOVWF      ?LocalText_main+11
	MOVLW      45
	MOVWF      ?LocalText_main+12
	CLRF       ?LocalText_main+13
	MOVLW      ?LocalText_main+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;JJYClock.mbas,725 :: 		all_ok = display_date_time( mark_count, time_code_index )
	MOVF       main_mark_count+0, 0
	MOVWF      FARG_display_date_time_mark_count+0
	MOVF       main_time_code_index+0, 0
	MOVWF      FARG_display_date_time_time_code_index+0
	CALL       _display_date_time+0
	MOVF       R0+0, 0
	MOVWF      main_all_ok+0
;JJYClock.mbas,726 :: 		for time_code_index = 40 to 48
	MOVLW      40
	MOVWF      main_time_code_index+0
L__main303:
;JJYClock.mbas,727 :: 		time_code[time_code_index] = 0
	MOVF       main_time_code_index+0, 0
	ADDLW      _time_code+0
	MOVWF      FSR
	CLRF       INDF+0
;JJYClock.mbas,728 :: 		next time_code_index
	MOVF       main_time_code_index+0, 0
	XORLW      48
	BTFSC      STATUS+0, 2
	GOTO       L__main306
	INCF       main_time_code_index+0, 1
	GOTO       L__main303
L__main306:
;JJYClock.mbas,729 :: 		time_code_index = 49
	MOVLW      49
	MOVWF      main_time_code_index+0
L__main300:
;JJYClock.mbas,730 :: 		end if
	GOTO       L__main298
;JJYClock.mbas,731 :: 		else if pulse_width < 650 then
L__main297:
	MOVLW      2
	SUBWF      _pulse_width+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main353
	MOVLW      138
	SUBWF      _pulse_width+0, 0
L__main353:
	BTFSC      STATUS+0, 0
	GOTO       L__main308
;JJYClock.mbas,732 :: 		jjy_code = 1         ' 0.5sec pulse
	MOVLW      1
	MOVWF      main_jjy_code+0
	GOTO       L__main309
;JJYClock.mbas,733 :: 		else
L__main308:
;JJYClock.mbas,734 :: 		jjy_code = 0         ' 0.8sec pulse
	CLRF       main_jjy_code+0
;JJYClock.mbas,735 :: 		end if end if
L__main309:
L__main298:
;JJYClock.mbas,736 :: 		end if
L__main265:
L__main261:
;JJYClock.mbas,738 :: 		signal_prev = signal_curr
	MOVF       main_signal_curr+0, 0
	MOVWF      main_signal_prev+0
;JJYClock.mbas,739 :: 		wend
	GOTO       L__main238
L_end_main:
	GOTO       $+0
; end of _main
